import * as v from 'valibot';
import type { InferModelTypes } from './u-model';
export declare namespace DcqlMdocCredential {
    const vNamespaces: v.RecordSchema<v.StringSchema<undefined>, v.RecordSchema<v.StringSchema<undefined>, v.UnknownSchema, undefined>, undefined>;
    const vModel: v.ObjectSchema<{
        readonly credential_format: v.LiteralSchema<"mso_mdoc", undefined>;
        readonly doctype: v.StringSchema<undefined>;
        readonly namespaces: v.RecordSchema<v.StringSchema<undefined>, v.RecordSchema<v.StringSchema<undefined>, v.UnknownSchema, undefined>, undefined>;
    }, undefined>;
    const model: import("./u-model").Model<v.ObjectSchema<{
        readonly credential_format: v.LiteralSchema<"mso_mdoc", undefined>;
        readonly doctype: v.StringSchema<undefined>;
        readonly namespaces: v.RecordSchema<v.StringSchema<undefined>, v.RecordSchema<v.StringSchema<undefined>, v.UnknownSchema, undefined>, undefined>;
    }, undefined>>;
    type Model = InferModelTypes<typeof model>;
    type NameSpaces = v.InferOutput<typeof vNamespaces>;
}
export type DcqlMdocCredential = DcqlMdocCredential.Model['Output'];
export declare namespace DcqlSdJwtVcCredential {
    const vClaims: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<import("./u-dcql.js").Json, import("./u-dcql.js").Json, v.BaseIssue<unknown>>, undefined>;
    const vModel: v.ObjectSchema<{
        readonly credential_format: v.PicklistSchema<["vc+sd-jwt", "dc+sd-jwt"], undefined>;
        readonly vct: v.StringSchema<undefined>;
        readonly claims: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<import("./u-dcql.js").Json, import("./u-dcql.js").Json, v.BaseIssue<unknown>>, undefined>;
    }, undefined>;
    const model: import("./u-model").Model<v.ObjectSchema<{
        readonly credential_format: v.PicklistSchema<["vc+sd-jwt", "dc+sd-jwt"], undefined>;
        readonly vct: v.StringSchema<undefined>;
        readonly claims: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<import("./u-dcql.js").Json, import("./u-dcql.js").Json, v.BaseIssue<unknown>>, undefined>;
    }, undefined>>;
    type Model = InferModelTypes<typeof model>;
    type Claims = Model['Output']['claims'];
}
export type DcqlSdJwtVcCredential = DcqlSdJwtVcCredential.Model['Output'];
export declare namespace DcqlW3cVcCredential {
    const vClaims: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<import("./u-dcql.js").Json, import("./u-dcql.js").Json, v.BaseIssue<unknown>>, undefined>;
    const vModel: v.ObjectSchema<{
        readonly credential_format: v.PicklistSchema<["jwt_vc_json-ld", "jwt_vc_json"], undefined>;
        readonly claims: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<import("./u-dcql.js").Json, import("./u-dcql.js").Json, v.BaseIssue<unknown>>, undefined>;
    }, undefined>;
    const model: import("./u-model").Model<v.ObjectSchema<{
        readonly credential_format: v.PicklistSchema<["jwt_vc_json-ld", "jwt_vc_json"], undefined>;
        readonly claims: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<import("./u-dcql.js").Json, import("./u-dcql.js").Json, v.BaseIssue<unknown>>, undefined>;
    }, undefined>>;
    type Model = InferModelTypes<typeof model>;
    type Claims = Model['Output']['claims'];
}
export type DcqlW3cVcCredential = DcqlW3cVcCredential.Model['Output'];
export declare namespace DcqlCredential {
    const vModel: v.VariantSchema<"credential_format", [v.ObjectSchema<{
        readonly credential_format: v.LiteralSchema<"mso_mdoc", undefined>;
        readonly doctype: v.StringSchema<undefined>;
        readonly namespaces: v.RecordSchema<v.StringSchema<undefined>, v.RecordSchema<v.StringSchema<undefined>, v.UnknownSchema, undefined>, undefined>;
    }, undefined>, v.ObjectSchema<{
        readonly credential_format: v.PicklistSchema<["vc+sd-jwt", "dc+sd-jwt"], undefined>;
        readonly vct: v.StringSchema<undefined>;
        readonly claims: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<import("./u-dcql.js").Json, import("./u-dcql.js").Json, v.BaseIssue<unknown>>, undefined>;
    }, undefined>, v.ObjectSchema<{
        readonly credential_format: v.PicklistSchema<["jwt_vc_json-ld", "jwt_vc_json"], undefined>;
        readonly claims: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<import("./u-dcql.js").Json, import("./u-dcql.js").Json, v.BaseIssue<unknown>>, undefined>;
    }, undefined>], undefined>;
    const vParseSuccess: v.ObjectSchema<{
        readonly success: v.LiteralSchema<true, undefined>;
        readonly typed: v.LiteralSchema<true, undefined>;
        readonly issues: v.OptionalSchema<v.UndefinedSchema<undefined>, undefined>;
        readonly input_credential_index: v.NumberSchema<undefined>;
        readonly claim_set_index: v.UnionSchema<[v.NumberSchema<undefined>, v.UndefinedSchema<undefined>], undefined>;
        readonly output: v.VariantSchema<"credential_format", [v.ObjectSchema<{
            readonly credential_format: v.LiteralSchema<"mso_mdoc", undefined>;
            readonly doctype: v.StringSchema<undefined>;
            readonly namespaces: v.RecordSchema<v.StringSchema<undefined>, v.RecordSchema<v.StringSchema<undefined>, v.UnknownSchema, undefined>, undefined>;
        }, undefined>, v.ObjectSchema<{
            readonly credential_format: v.PicklistSchema<["vc+sd-jwt", "dc+sd-jwt"], undefined>;
            readonly vct: v.StringSchema<undefined>;
            readonly claims: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<import("./u-dcql.js").Json, import("./u-dcql.js").Json, v.BaseIssue<unknown>>, undefined>;
        }, undefined>, v.ObjectSchema<{
            readonly credential_format: v.PicklistSchema<["jwt_vc_json-ld", "jwt_vc_json"], undefined>;
            readonly claims: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<import("./u-dcql.js").Json, import("./u-dcql.js").Json, v.BaseIssue<unknown>>, undefined>;
        }, undefined>], undefined>;
    }, undefined>;
    const vParseFailure: v.ObjectSchema<{
        readonly success: v.LiteralSchema<false, undefined>;
        readonly typed: v.BooleanSchema<undefined>;
        readonly output: v.UnknownSchema;
        readonly issues: v.SchemaWithPipe<[v.ArraySchema<v.UnknownSchema, undefined>, v.CustomSchema<[unknown, ...unknown[]], undefined>]>;
        readonly input_credential_index: v.NumberSchema<undefined>;
        readonly claim_set_index: v.UnionSchema<[v.NumberSchema<undefined>, v.UndefinedSchema<undefined>], undefined>;
    }, undefined>;
    const model: import("./u-model").Model<v.VariantSchema<"credential_format", [v.ObjectSchema<{
        readonly credential_format: v.LiteralSchema<"mso_mdoc", undefined>;
        readonly doctype: v.StringSchema<undefined>;
        readonly namespaces: v.RecordSchema<v.StringSchema<undefined>, v.RecordSchema<v.StringSchema<undefined>, v.UnknownSchema, undefined>, undefined>;
    }, undefined>, v.ObjectSchema<{
        readonly credential_format: v.PicklistSchema<["vc+sd-jwt", "dc+sd-jwt"], undefined>;
        readonly vct: v.StringSchema<undefined>;
        readonly claims: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<import("./u-dcql.js").Json, import("./u-dcql.js").Json, v.BaseIssue<unknown>>, undefined>;
    }, undefined>, v.ObjectSchema<{
        readonly credential_format: v.PicklistSchema<["jwt_vc_json-ld", "jwt_vc_json"], undefined>;
        readonly claims: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<import("./u-dcql.js").Json, import("./u-dcql.js").Json, v.BaseIssue<unknown>>, undefined>;
    }, undefined>], undefined>>;
    type Model = InferModelTypes<typeof model>;
}
export type DcqlCredential = DcqlCredential.Model['Output'];
//# sourceMappingURL=u-dcql-credential.d.ts.map