import * as v from 'valibot';
import type { UnknownBaseSchema } from './u-model';
export declare const idRegex: RegExp;
export declare const vNonEmptyArray: <T extends unknown[]>() => v.CustomSchema<[T[number], ...T], undefined>;
export declare const vIdString: v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, undefined>]>;
export type Json = string | number | boolean | null | {
    [key: string]: Json;
} | Json[];
export declare const vWithJT: <Schema extends UnknownBaseSchema>(schema: Schema) => v.SchemaWithPipe<[v.CustomSchema<v.InferInput<Schema>, undefined>, v.RawTransformAction<v.InferInput<Schema>, v.InferOutput<Schema>>]>;
export declare const vJsonLiteral: v.UnionSchema<[v.StringSchema<undefined>, v.NumberSchema<undefined>, v.BooleanSchema<undefined>, v.NullSchema<undefined>], undefined>;
export type JsonLiteral = v.InferOutput<typeof vJsonLiteral>;
export declare const vJson: v.GenericSchema<Json>;
export declare const vJsonWithJT: v.GenericSchema<Json>;
export declare const vJsonRecord: v.RecordSchema<v.StringSchema<undefined>, v.GenericSchema<Json, Json, v.BaseIssue<unknown>>, undefined>;
export type JsonRecord = v.InferOutput<typeof vJsonRecord>;
export declare const vStringToJson: v.RawTransformAction<string, Json>;
//# sourceMappingURL=u-dcql.d.ts.map