"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.vStringToJson = exports.vJsonRecord = exports.vJsonWithJT = exports.vJson = exports.vJsonLiteral = exports.vWithJT = exports.vIdString = exports.vNonEmptyArray = exports.idRegex = void 0;
const v = __importStar(require("valibot"));
exports.idRegex = /^[a-zA-Z0-9_-]+$/;
const vNonEmptyArray = () => {
    return v.custom(input => input.length > 0 ? true : false);
};
exports.vNonEmptyArray = vNonEmptyArray;
exports.vIdString = v.pipe(v.string(), v.regex(exports.idRegex));
function isToJsonable(value) {
    if (value === null || typeof value !== 'object')
        return false;
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-explicit-any, @typescript-eslint/no-unsafe-member-access
    const toJsonFn = value.toJson;
    return typeof toJsonFn === 'function';
}
const vWithJT = (schema) => v.pipe(v.custom(() => true), v.rawTransform(({ dataset, addIssue, NEVER }) => {
    const result = v.safeParse(schema, dataset.value);
    if (result.success)
        return dataset.value;
    if (!isToJsonable(dataset.value)) {
        for (const safeParseIssue of result.issues) {
            addIssue({
                ...safeParseIssue,
                expected: safeParseIssue.expected ?? undefined,
            });
        }
        return NEVER;
    }
    let json;
    try {
        json = dataset.value.toJson();
    }
    catch (error) {
        for (const safeParseIssue of result.issues) {
            addIssue({
                ...safeParseIssue,
                expected: safeParseIssue.expected ?? undefined,
            });
        }
        addIssue({ message: 'Json Transformation failed' });
        return NEVER;
    }
    const safeParseResult = v.safeParse(schema, json);
    if (safeParseResult.success)
        return dataset.value;
    for (const safeParseIssue of safeParseResult.issues) {
        addIssue({
            ...safeParseIssue,
            expected: safeParseIssue.expected ?? undefined,
        });
    }
    return NEVER;
}));
exports.vWithJT = vWithJT;
exports.vJsonLiteral = v.union([
    v.string(),
    v.number(),
    v.boolean(),
    v.null(),
]);
exports.vJson = v.lazy(() => v.union([exports.vJsonLiteral, v.array(exports.vJson), v.record(v.string(), exports.vJson)]));
exports.vJsonWithJT = v.lazy(() => (0, exports.vWithJT)(v.union([exports.vJsonLiteral, v.array(exports.vJson), v.record(v.string(), exports.vJson)])));
exports.vJsonRecord = v.record(v.string(), exports.vJson);
exports.vStringToJson = v.rawTransform(({ dataset, addIssue, NEVER }) => {
    try {
        return JSON.parse(dataset.value);
    }
    catch (error) {
        addIssue({ message: 'Invalid JSON' });
        return NEVER;
    }
});
//# sourceMappingURL=u-dcql.js.map